<template>
  <box :loading="loading">
    <template v-slot:title>{{ capitalizeFirstLetter(action) }} Role</template>

    <div class="px-3 w-full">
      <lull-input
        label="Name:"
        :class="[hasError('name') && 'shake']"
        :message="getValidationMessage('name')"
        :status="getValidationStatus('name')"
        v-model="role.name"
      />
    </div>

    <div class="px-3 pt-5 w-full">
      <lull-input
        label="Description:"
        :class="[hasError('description') && 'shake']"
        :message="getValidationMessage('description')"
        :status="getValidationStatus('description')"
        v-model="role.description"
      />
    </div>

    <template v-slot:footer>
      <div class="flex flex-row justify-end px-3 pt-3 pr-6 pb-6">
        <lull-button type="danger" class="w-28" @click="$router.push('/roles')">
          Cancel
        </lull-button>
        <lull-button type="info" class="ml-3 w-28" @click="save()">
          Save
        </lull-button>
      </div>
    </template>
  </box>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  onBeforeMount,
  onBeforeUnmount,
  reactive,
} from 'vue';
import { capitalizeFirstLetter, isUndefined } from '@/core/helpers/util';
import { ManageAction } from '@/core/types/ManageAction';
import { useStore } from '@/store';
import { useRouter, useRoute } from 'vue-router';
import { required } from '@vuelidate/validators';
import useValidation from '@/core/composables/useValidations';
import { useLullToast } from 'lull-ui';
import { Role } from '@/core/models/role/Role';
import { RoleAction, RoleModule, RoleMutation } from '@/store/Roles';

export default defineComponent({
  name: 'role',
  props: {
    action: { type: String, required: true, default: ManageAction.Create },
  },
  setup(props) {
    const store = useStore();
    const router = useRouter();
    const route = useRoute();
    const loading = computed(() => store.getters['role/loading']);
    const toast = useLullToast();
    const role: Partial<Role> = reactive({});

    const rules = {
      name: { required },
      description: { required },
    };

    const { validation, getValidationMessage, getValidationStatus, hasError } =
      useValidation(rules, role);

    async function save(): Promise<void> {
      validation.value.$touch();
      if (validation.value.$invalid) {
        return;
      }

      const action =
        props.action === ManageAction.Create
          ? `role/${RoleAction.CreateRole}`
          : `role/${RoleAction.UpdateRole}`;

      await store.dispatch(action, role);
      toast.success({
        title: 'Success',
        message: `Role ${props.action}d.`,
      });
      router.push(`/roles`);
    }

    async function setup(): Promise<void> {
      if (props.action === ManageAction.Edit) {
        const results = await store.dispatch(
          `role/${RoleAction.GetRole}`,
          route.params.id
        );

        if (isUndefined(results)) {
          toast.error({
            title: 'Error',
            message: `Can not find role with id ${route.params.id}.`,
          });
          router.push('/roles');
        }

        if (results.protected) {
          toast.error({
            title: 'Error',
            message: 'You can not modify a protected role.',
          });

          router.push('/roles');
        }
        Object.assign(role, results);
      }

      store.commit(`role/${RoleMutation.SetLoading}`, false);
    }

    onBeforeMount(async () => {
      await store.registerModule('role', RoleModule);
      await setup();
    });

    onBeforeUnmount(async () => {
      await store.unregisterModule('role');
    });

    return {
      role,
      capitalizeFirstLetter,
      loading,
      ManageAction,
      save,
      getValidationMessage,
      getValidationStatus,
      hasError,
    };
  },
});
</script>
